require "import"
import "android.widget.*"
import "android.view.*"
import "android.content.*"
import "android.os.*"
import "android.app.*"
import "java.io.File"
import "android.net.Uri"

activity.setTheme(android.R.style.Theme_DeviceDefault)
activity.setTitle("Root Access Checker, developed by: Sujan Rai")

-- Show toast
function showToast(msg)
  Toast.makeText(activity, msg, Toast.LENGTH_LONG).show()
end

-- Check if device is rooted
function isDeviceRooted()
  local paths = {
    "/system/bin/su",
    "/system/xbin/su",
    "/sbin/su",
    "/system/sd/xbin/su",
    "/system/bin/failsafe/su",
    "/data/local/xbin/su",
    "/data/local/bin/su",
    "/data/local/su"
  }

  for _, path in ipairs(paths) do
    local file = File(path)
    if file.exists() then
      return true
    end
  end
  return false
end

-- Layout
layout = {
  LinearLayout,
  orientation = "vertical",
  padding = "16dp",
  gravity = "center",
  {
    TextView,
    text = "Welcome to Root Access Checker",
    textSize = "18sp",
    gravity = "center",
    textColor = 0xff000000,
  },
  {
    TextView,
    text = "Hi, this tool is created by Sujan Rai at Tech Visionary",
    textSize = "14sp",
    gravity = "center",
    textColor = 0xff444444,
  },
  {
    TextView,
    text = "Join my Telegram for free/modded apps, tools, tutorials and more!",
    textSize = "14sp",
    gravity = "center",
    textColor = 0xff444444,
  },
  {
    Button,
    id = "joinTelegram",
    text = "Join Telegram"
  },
  {
    TextView,
    text = "Press the button below to check whether root access is enabled or not.",
    textSize = "16sp",
    gravity = "center",
    textColor = 0xff000000,
    paddingTop = "12dp",
    paddingBottom = "12dp"
  },
  {
    Button,
    id = "checkRoot",
    text = "Check Root Access"
  },
  {
    Button,
    id = "exitBtn",
    text = "Exit",
    layout_marginTop = "10dp"
  }
}

-- Load layout
pcall(function()
  activity.setContentView(loadlayout(layout))
end,
function(err)
  showToast("Layout error: " .. tostring(err))
end)

-- Join Telegram button
joinTelegram.onClick = function()
  pcall(function()
    local url = "https://t.me/techvisionarynepal"
    local intent = Intent(Intent.ACTION_VIEW, Uri.parse(url))
    activity.startActivity(intent)
  end,
  function(err)
    showToast("Error opening Telegram: " .. tostring(err))
  end)
end

-- Root check button
checkRoot.onClick = function()
  pcall(function()
    if isDeviceRooted() then
      showToast("Device is rooted!")
    else
      showToast("Device is NOT rooted.")
    end
  end,
  function(err)
    showToast("Error checking root: " .. tostring(err))
  end)
end

-- Exit button
exitBtn.onClick = function()
  activity.finish()
end